<template>
  <div class="app-container">
    <el-row type="flex" justify="space-between" ref="listQueryContainer" class="query-container">
      <el-col>
        <el-form :inline="true" style="flex-wrap: wrap" :model="listQuery" ref="listQuery" @submit.native.prevent @keyup.enter.native="onSubmit">
          <el-form-item label="姓名" prop="nickname">
            <el-input v-model.trim="listQuery.nickname" maxlength="16" placeholder="请输入姓名" clearable @keyup.enter.native="onSubmit">
              <i slot="suffix" class="el-input__icon el-icon-search" @click="onFilterChange"></i>
            </el-input>
          </el-form-item>
          <el-form-item label="性别" prop="gender">
            <el-select v-model="listQuery.gender" placeholder="请选择性别" clearable @change="onFilterChange">
              <el-option v-for="item in genderList" :key="item.id" :label="item.label" :value="item.id">
              </el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="时间范围" prop="dateRange">
            <el-date-picker
                v-model="listQuery.dateRange"
                value-format="timestamp"
                type="daterange"
                range-separator="-"
                start-placeholder="开始日期"
                end-placeholder="结束日期"
                :default-time="['00:00:00', '23:59:59']"
                @change="onFilterChange">
            </el-date-picker>
          </el-form-item>
          <el-form-item label-width="0">
            <el-button @click="onFilterChange" type="primary">查询</el-button>
            <el-button @click="resetFields" plain type="primary">重置</el-button>
            <el-button @click="onExport" plain type="primary">导出</el-button>
          </el-form-item>
        </el-form>
      </el-col>
      <form-clear :shrinkable="shrinkable" @clear="resetFields" @change="onExpansion"/>
    </el-row>
    <el-row>
      <el-button @click="onAdd" type="primary">添加</el-button>
      <el-button v-if="!editing" @click="onEdit" plain type="primary">批量删除</el-button>
      <el-button v-if="editing" @click="onDeleteSelect" type="danger">删除</el-button>
      <el-button v-if="editing" @click="onCancel" plain>取消</el-button>
    </el-row>
    <el-table :data="list" border stripe highlight-current-row ref="table" class="mt10" @sort-change="onSortChange" @selection-change="onTableSelectionChange" @row-click="onRowClick" @row-dblclick="onUpdate">
      <el-table-column v-if="editing" type="selection" width="55" fixed></el-table-column>
      <el-table-column type="index" :index="indexCompute" label="序号" align="center" fixed="left" width="60px"/>
      <el-table-column prop="nickname" label="姓名" align="center" width="80px" fixed="left"/>
      <el-table-column prop="gender" label="头像" align="center" width="80px">
         <template v-slot="scope">
          <el-avatar icon="el-icon-user-solid" :src="scope.row.avatarUrl" fit="cover"></el-avatar>
        </template>
      </el-table-column>
      <el-table-column prop="gender" label="性别" align="center" width="60px">
         <template v-slot="scope">
          {{ scope.row.gender | parseGender }}
        </template>
      </el-table-column>
      <el-table-column prop="skillList" label="技能" align="center" min-width="180px">
         <template v-slot="scope">
          {{ scope.row.skillList.join("、") }}
        </template>
      </el-table-column>
      <el-table-column prop="createTime" label="创建时间" sortable="custom" align="center" width="160px">
         <template v-slot="scope">
          {{ scope.row.createTime | dateFormat }}
        </template>
      </el-table-column>
      <el-table-column prop="enable" label="启用状态" align="center" min-width="160px">
         <template v-slot="scope">
          <el-radio-group v-model="scope.row.enable" @change="onStatusChange(scope.row)">
            <el-radio v-for="item in optionList" :key="item.value" :label="item.value">{{ item.name }}</el-radio>
          </el-radio-group>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" min-width="210px">
         <template v-slot="scope">
          <el-link type="primary" icon="el-icon-view" @click="onDetail(scope.row)">详情</el-link>
          <el-link type="primary" icon="el-icon-edit" @click="onUpdate(scope.row)" class="ml20">编辑</el-link>
          <el-link type="danger" icon="el-icon-delete" @click="onDelete(scope.row)" class="ml20">删除</el-link>
        </template>
      </el-table-column>
    </el-table>
    <pagination :total="total" :page.sync="listQuery.page" :size.sync="listQuery.size" @change="onPageChange"/>

    <el-dialog title="导出" :visible.sync="exportVisible" :close-on-click-modal="false" :close-on-press-escape="false" width="600px">
      <el-progress :text-inside="true" :stroke-width="24" :percentage="exportProgress" status="success"></el-progress>
      <el-button slot="footer" @click="onCancelExport">取 消</el-button>
    </el-dialog>

    <dialog-edit v-if="editDialogVisible" :visible.sync="editDialogVisible" :data="selectItem" @add="onAddComplete" @update="onUpdateComplete"/>
    <dialog-detail v-if="detailDialogVisible" :visible.sync="detailDialogVisible" :data="selectItem"/>
  </div>
</template>

<script>
import FormClear from "@/components/FormClear";
import Pagination from "@/components/Pagination"
import DialogEdit from "./dialogEdit";
import DialogDetail from "./dialogDetail";
import {dateFormat} from "@/utils/dateUtil"

export default {
  name: "tableList",
  components: {FormClear, Pagination, DialogEdit, DialogDetail},
  data() {
    const defaultStartTime = new Date(dateFormat("yyyy/MM/dd 00:00:00", new Date())).getTime();
    const defaultEndTime = new Date(dateFormat("yyyy/MM/dd 23:59:59", new Date())).getTime();

    return {
      shrinkable: false, // 查询条件是否可以展开
      listQuery: { // 查询对象
        nickname: undefined,
        gender: undefined,
        dateRange: [defaultStartTime, defaultEndTime], // 时间范围
        startTime: defaultStartTime,
        endTime: defaultEndTime,
        order: undefined,
        page: 1,
        size: 10
      },

      whetherList: [{id: 1, label: "是"}, {id: 2, label: "否"}], // 是否列表
      optionList: [{name: '启用', value: true}, {name: '禁用', value: false}], // 启用状态列表
      genderList: [{id: 1, label: "男"}, {id: 2, label: "女"}], // 性别列表

      defaultStartTime,
      defaultEndTime,

      list: [], // 结果列表
      total: 0, // 总结果数量

      exportVisible: false, // 是否显示导出对话框
      exportData: [], // 导出数据
      exportPagination: { // 导出分页
        page: 1,
        size: 500,
      },
      exportProgress: 0, // 导出进度
      exportCancel: false, // 是否取消导出

      detailDialogVisible: false, // 详情对话框是否可见
      editDialogVisible: false, // 编辑对话框是否可见

      editing: false, // 表格编辑中

      selectItem: undefined, // 选中的单条记录
      selectIds: undefined // 选中多条记录的id
    }
  },

  watch: {
    // 监听日期范围变化
    'listQuery.dateRange'(value) {
      if (value) {
        this.listQuery.startTime = value[0];
        this.listQuery.endTime = value[1];
      } else {
        this.listQuery.startTime = this.defaultStartTime;
        this.listQuery.endTime = this.defaultEndTime;
      }
    }
  },

  // 页面创建
  created() {
    this.initData();
  },

  // 页面挂载
  mounted() {
    this.initQuery();
    this.getList();
    this.initView();
  },

  // keep-alive 显示界面时调用
  activated() {
  },

  // keep-alive 页面隐藏
  deactivated() {
  },

  methods: {
    // 表格索引
    indexCompute(index) {
      return index + 1 + (this.listQuery.page - 1) * this.listQuery.size;
    },

    // 初始化查询条件
    initQuery() {
      if (this.$store.state.app.paramCache) {
        let query = this.$storage.getData(this.$options.name);
        if (Object.keys(query).length > 0) {
          this.listQuery = query;
          if (query.order) {
            this.$refs.table.sort(query.order.substring(1), query.order.substring(0, 1) === "+" ? "ascending" : "descending");
          } else {
            this.$refs.table.clearSort();
          }
        }
      }
    },

    // 初始化数据
    initData() {
    },

    // 初始化视图
    initView() {
      this.$nextTick(() => {
        this.shrinkable = this.$store.state.app.filterShrink && this.$refs['listQuery'].$el.offsetHeight > 51;
      })
    },

    // 展开/收起查询条件
    onExpansion(show) {
      this.$refs['listQueryContainer'].$el.style.height = show ? "auto" : "51px";
    },

    // 表单提交
    onSubmit() {
      this.onFilterChange();
    },

    // 表单清除
    resetFields() {
      this.$refs['listQuery'].resetFields();
      this.listQuery.order = undefined;
      this.$refs.table.clearSort();
      this.onFilterChange();
    },

    // 添加
    onAdd() {
      this.onCancel();
      this.selectItem = undefined;
      this.editDialogVisible = true;
    },

    // 添加完成
    onAddComplete() {
      this.onFilterChange();
    },

    // 编辑
    onEdit() {
      this.editing = true;
    },

    // 删除选中
    onDeleteSelect() {
      this.$confirm('此操作将永久删除选中的记录, 是否继续?', '提示', {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        // TODO 地址、参数
        this.$axios.delete("/check/check/item/delete", {params: this.selectIds.join(",")}).then(() => {
          if (this.list.length <= this.selectIds.length && this.listQuery.curPage > 1) {
            this.listQuery.curPage -= 1;
          }
          this.getList();
        });
      }).catch(() => {
        this.$message.info("取消操作!")
      });
    },

    // 取消编辑
    onCancel() {
      this.$refs['table'].clearSelection();
      this.editing = false;
    },

    // 启用状态改变
    onStatusChange(item) {
      console.log(item);
    },

    // 详情
    onDetail(item) {
      this.selectItem = item;
      this.detailDialogVisible = true;
    },

    // 更新
    onUpdate(item) {
      this.selectItem = item;
      this.editDialogVisible = true;
    },

    // 更新完成
    onUpdateComplete() {
      this.onFilterChange();
    },

    // 删除
    onDelete(item) {
      this.$confirm('此操作将永久删除该记录, 是否继续?', '提示', {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        this.$axios.delete(`/data/delete/${item.id}`).then(() => {
          if (this.list.length === 1 && this.listQuery.page > 1) {
            this.listQuery.page -= 1;
          }
          this.getList();
        });
      }).catch(() => {
        this.$message.info("取消操作!")
      });
    },

    // 数据选择
    onTableSelectionChange(val) {
      this.selectIds = val.map(item => item.id);
    },

    // 排序改变
    onSortChange({prop, order}) {
      if (order === "ascending") {
        this.listQuery.order = "+" + prop;
      } else if (order === "descending") {
        this.listQuery.order = "-" + prop;
      } else {
        this.listQuery.order = undefined;
      }
      this.onFilterChange();
    },

    // 行点击
    onRowClick(row, column, event) {
      this.$refs["table"].setCurrentRow(row);
      if (this.editing) {
        this.$refs["table"].toggleRowSelection(row);
      }
    },

    // 条件改变
    onFilterChange() {
      this.listQuery.page = 1;
      this.$nextTick(this.getList);
    },

    // 页码改变
    onPageChange() {
      this.getList();
    },

    // 加载列表
    getList() {
      // 缓存参数
      if (this.$store.state.app.paramCache) {
        this.$storage.setData(this.$options.name, this.listQuery);
      }

      this.$axios.get("/data/list", {params: this.listQuery}).then(data => {
        this.list = data.list;
        this.total = data.total;
        this.$refs["table"].doLayout();
        this.onCancel();
      });
    },

    // 导出数据
    onExport() {
      if (this.total > 0) {
        this.exportPagination.page = 1;
        this.exportData = [];
        this.exportVisible = true;
        this.getExportData();
      }
    },

    // 取消导出
    onCancelExport() {
      this.exportVisible = false;
      this.exportCancel = true;
    },

    // 获取数据并导出
    getExportData() {
      if (!this.exportCancel) {
        this.$axios.get("/data/list", {params: {...this.listQuery, ...this.exportPagination}}).then(data => {
          this.exportPagination.page++;
          this.exportData = this.exportData.concat(data.list);
          this.exportProgress = Math.round(this.exportData.length * 100 / this.total);
          if (this.exportData.length < this.total && data.list.length > 0) {
            this.getExportData();
          } else {
            this.exportVisible = false;
            // "list": [{
            //   "id": 1,
            //   "nickname": "张三",
            //   "gender": 1,
            //   "skillList": ["Java", "C", "Web"],
            //   "avatarUrl": "https://timgsa.baidu.com/timg?image&quality=80&size=b9999_10000&sec=1590331929931&di=53e7c5251eb9fb69649593884580b84c&imgtype=0&src=http%3A%2F%2Fimg.pconline.com.cn%2Fimages%2Fupload%2Fupc%2Ftx%2Fsoftbbs%2F1003%2F07%2Fc0%2F3134443_1267900790753_1024x1024soft.jpg",
            //   "createTime": 1588749798296
            // }]

            let tHeader = ["序号", "姓名", "性别", "技能", "头像", "添加时间"];
            let filterVal = ["index", "nickname", "gender", "skillList", "avatarUrl", "createTime"];
            let data = this.exportData.map((value, index) => filterVal.map((key) => {
              if (key === "index") {
                return index + 1;
              } else if (key === "gender") {
                return this.genderList.find(item => item.id === value[key]).label;
              } else if (key === "skillList") {
                return value[key].join(",");
              } else if (key === "createTime") {
                return dateFormat("yyyy-MM-dd HH:mm:ss", new Date(value[key]));
              } else {
                return value[key];
              }
            }));
            import('@/utils/Export2Excel').then(excel => {
              excel.export_json_to_excel({
                header: tHeader, // 表头 必填
                data, // 具体数据 必填
                filename: '用户信息列表', // 非必填
                autoWidth: true, // 非必填
                bookType: 'xlsx' // 非必填
              })
            })
          }
        });
      }
    }
  }
}
</script>

<style scoped lang="scss">
.app-container {

}
</style>
